/* 
        Ak5XImage.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        Copyright (c)1997 Daisuke Iizuka(iizuka@masada.t.u-tokyo.ac.jp)
        code (iizuka@masada.t.u-tokyo.ac.jp)󤬽񤤤
        Ǥ
*/

//C
#include <stdio.h>
//#include <cstdio>
#include <assert.h>
//#include <cassert>

//X
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#ifdef MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif //MITSHM
#include "Ak5XImage.h"


////////////////////////////////////////////////////////////////////////
// class Ak5XNormalImage
////////////////////////////////////////////////////////////////////////


//
// 󥹥ȥ饯
//
Ak5XNormalImage::Ak5XNormalImage(Display *dpy, Visual *visual,
				 unsigned int depth, int format) :
  display(dpy)
{
  assert(format == XYPixmap || format == ZPixmap);

  pImgData = new unsigned char[VRAM_MAX_X * VRAM_MAX_Y / 8 * depth];

  ximage = XCreateImage(display, visual, depth, format, 0, (char *)pImgData,
			VRAM_MAX_X, VRAM_MAX_Y, 8, 0);

  if (format == XYPixmap) {
    ximage->byte_order = MSBFirst;
    ximage->bitmap_bit_order = MSBFirst;
  }
};


//
// ǥȥ饯
//
Ak5XNormalImage::~Ak5XNormalImage(void)
{
  delete[] pImgData;

  ximage->data = NULL;
  XDestroyImage(ximage);
}


//
// Window or Pixmap ɽ
//
void Ak5XNormalImage::XPutImage(Drawable drawable, GC gc,
				int src_x, int src_y, int dst_x, int dst_y,
				unsigned width, unsigned height)
{
  ::XPutImage(display, drawable, gc, ximage, src_x, src_y, dst_x, dst_y,
	      width, height);
}

#ifdef MITSHM
////////////////////////////////////////////////////////////////////////
// class Ak5XShmImage
////////////////////////////////////////////////////////////////////////


//
// 󥹥ȥ饯
//
Ak5XShmImage::Ak5XShmImage(Display *dpy, Visual *visual,
			   unsigned int depth, int format) :
  display(dpy)
{
  assert(format == XYPixmap || format == ZPixmap);

  // XImage ¤Τ
  ximage = XShmCreateImage(display, visual, depth, format, NULL, &shminfo,
			   VRAM_MAX_X, VRAM_MAX_Y);

  // Shared memory segment 
  shminfo.shmid = shmget(IPC_PRIVATE, 
			 ximage->bytes_per_line * ximage->height * depth,
			 IPC_CREAT | 0777);
  if (shminfo.shmid == -1) // ݼ
    perror("can not get MITSHM info.");

  // Shared memory segment  attach 
  pImgData = (unsigned char *)shminfo.shmaddr = ximage->data =
    shmat(shminfo.shmid, 0, 0);
  if ((int)(shminfo.shmaddr) == -1) // attach 
    perror("can not allocate MITSHM.");

  shminfo.readOnly = False; // X Server  shared memory 񤭹߲ǽ

  // X Server  shared memory ξΤ餻
  if ((iXShmAttach = XShmAttach(display, &shminfo)) == False) 
    perror("can not attach MITSHM.");
};


//
// ǥȥ饯
//
Ak5XShmImage::~Ak5XShmImage(void)
{
  // X Server  shared memory Ѥʤ褦
  if (iXShmAttach != False)
    XShmDetach(display, &shminfo);

  // Shared memory  detach 
  if ((int)(shminfo.shmaddr) != -1)
    shmdt(shminfo.shmaddr);

  // Shared memory 
  if (shminfo.shmid != -1)
    shmctl(shminfo.shmid, IPC_RMID, 0);

  // XImage ¤Τ
  ximage->data = NULL;  // Ѥ shared memory  free() ʤ褦ˤ
  XDestroyImage(ximage);
}


//
// Window or Pixmap ɽ
//
void Ak5XShmImage::XPutImage(Drawable drawable, GC gc,
			     int src_x, int src_y,
			     int dst_x, int dst_y,
			     unsigned width, unsigned height)
{
  XShmPutImage(display, drawable, gc, ximage, src_x, src_y, dst_x, dst_y,
	       width, height, False);
}
#endif //MITSHM
// end Ak5XImage.cc


