/* 
        Ak5XImage.h

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	Copyright (c)1997 Daisuke Iizuka(iizuka@masada.t.u-tokyo.ac.jp)
        code (iizuka@masada.t.u-tokyo.ac.jp)󤬽񤤤
        Ǥ
*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#ifdef MITSHM
#include <X11/extensions/XShm.h>
#endif //MITSHM

#ifndef ak5_ximage_h
#define ak5_ximage_h
////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////

const int VRAM_MAX_X = 640; // 640 * 409 < 32768 < 640 * 410 
const int VRAM_MAX_Y = 410; // VRAM_MAX_Y = 409 + 1

////////////////////////////////////////////////////////////////////////
// ݥ١饹
////////////////////////////////////////////////////////////////////////
class Ak5XImage {
public:
  virtual ~Ak5XImage(void){};
  virtual void XPutImage(Drawable drawable, GC gc,
			 int src_x, int src_y, int dst_x, int dst_y,
			 unsigned width, unsigned height) = 0;
  virtual unsigned char *GetImgPtr(void) = 0;
};


////////////////////////////////////////////////////////////////////////
// ̤ XImage Ѥ饹
////////////////////////////////////////////////////////////////////////
class Ak5XNormalImage : public Ak5XImage {
private:
  Display       *display;
  XImage        *ximage;
  unsigned char *pImgData;

public:
  Ak5XNormalImage(Display *dpy, Visual *visual,
		  unsigned int depth, int format);
  ~Ak5XNormalImage(void);
  void XPutImage(Drawable drawable, GC gc,
		 int src_x, int src_y, int dst_x, int dst_y,
		 unsigned width, unsigned height);
  unsigned char *GetImgPtr(void){ return pImgData; };
};

#ifdef MITSHM
////////////////////////////////////////////////////////////////////////
// MIT-SHM Ѥ饹
////////////////////////////////////////////////////////////////////////
class Ak5XShmImage : public Ak5XImage {
private:
  Display         *display;
  XImage          *ximage;
  XShmSegmentInfo  shminfo;
  unsigned char   *pImgData;
  int              iXShmAttach;

public:
  Ak5XShmImage(Display *dpy, Visual *visual,
	       unsigned int depth, int format);
  ~Ak5XShmImage(void);
  void XPutImage(Drawable drawable, GC gc,
		 int src_x, int src_y, int dst_x, int dst_y,
		 unsigned width, unsigned height);
  unsigned char *GetImgPtr(void){ return pImgData; };
};
#endif//MITSHM
#endif //ak5_ximage_h
// end Ak5XImage.h
