/* 
        CopyImage2Root.cc
        $BJI;f5!G=$rDs6!$9$k%/%i%9(B
	
        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        $B$3$N%3!<%I$O;3H($,=q$$$?$b$N$G$9!#(B
*/
#include <stdlib.h>
//#include <cstdlib>

#include "CopyImage2Root.h"

CopyImage2Root::CopyImage2Root (Display* maslDisplay,int maslScreen,
				Window maslWindow,long planeMask=~0L):
  display (maslDisplay),screen (maslScreen),window (maslWindow),
  isButton1Pressed (False),xPressed (0),yPressed (0),
  isRectangleDrawed (False),oldLeft (0),oldTop (0),oldWidth (0),oldHeight (0)
{
  ///////////////////////////////////////////////////$B2hA|IA2hMQ$N(BGC$B$r3NJ](B
  gc=XCreateGC (display,window,0,0);

  ////////////////$B%i%P!<%P%s%IIA2hMQ$N(BGC$B$r3NJ](B
  lineGc=XCreateGC (display,window,0,0);
  XSetLineAttributes (display,lineGc,1,LineSolid,CapButt,JoinMiter);
  XSetForeground (display,lineGc,0xffffffff);
  XSetBackground (display,lineGc,0);
  XSetFunction (display,lineGc,GXxor);
  XSetPlaneMask(display,lineGc,planeMask);

  //////////////////////////////////////$B8=:_$N2hA|$r3P$($F$*$/(B
  Window dummyRootWindow;//$B0J2<$N(Bdummy$B2?$H$+$O;H$o$J$$!#(B
  int dummyX;//$B0z?t$r9g$o$;$k0Y$@$1$KMQ0U$7$?!#(B
  int dummyY;
  unsigned int dummyBorder;
  XGetGeometry (display,window,&dummyRootWindow,&dummyX,&dummyY,
		&windowWidth,&windowHeight,&dummyBorder,&depth);
  Pixmap fgpixmap=XCreatePixmap (display,window,
				 windowWidth,windowHeight,depth);
  XCopyArea (display,window,fgpixmap,gc,0,0,windowWidth,windowHeight,0,0);
  XSetWindowBackgroundPixmap (display,window,fgpixmap);
  XFreePixmap (display,fgpixmap);
}


CopyImage2Root::~CopyImage2Root ()
{
  XFreeGC (display,gc);
  XFreeGC (display,lineGc);
  XSetWindowBackground (display,window,BlackPixel (display,screen));
}

void CopyImage2Root::copyImage2Root ()
{
  XEvent event;
  for (;;)
    {
      XNextEvent (display,&event);
      switch (event.type)
	{
	case ButtonPress:
	  if (event.xbutton.button!=1)
	    return;//button1$B0J30$N(Bbutton$B$,2!$5$l$?$iDL>o:F@8$KI|5"(B
	  
	  ///////////////////////////////////////click$B$5$l$?>l=j$r3P$($F$*$/(B
	  isButton1Pressed=True;
	  xPressed=event.xbutton.x;
	  yPressed=event.xbutton.y;
	  break;

	case MotionNotify:
	  if (!isButton1Pressed)
	    break;//drag$B$7$F$k$N$G$J$1$l$P2?$b$7$J$$(B
	  whenMotionNotify (event);
	  break;

	case ButtonRelease:
	  if (!isButton1Pressed||event.xbutton.button!=1)
	    break;//button1$B$G(Bdrag$B$5$l$?$N$G$J$1$l$P2?$b$7$J$$!#(B
	  whenButtonReleased (event);
	  break;

	case KeyPress:
	  whenKeyPressed ();
	  return;//$B2?$+(Bkey$B$,N%$5$l$?;~$ODL>o:F@8$KLa$k(B
	  break;//$BG0$N0Y(B

	default:
	  whenDefault ();
	  break;
	}
    }
}

void CopyImage2Root::whenMotionNotify (XEvent& event)
{
  //mouse$B$G;XDj$5$l$?=j$KD9J}7A$rIA$/(B
  //////////////////////////////$BA02sIA$$$?D9J}7A$r>C$9(B
  if (isRectangleDrawed)
    {
      XDrawRectangle (display,window,lineGc,
		      oldLeft,oldTop,oldWidth,oldHeight);
    }

  //////////////////////////$BD9J}7A$rIA$/(B
  int tmpLeft=(xPressed<event.xmotion.x)?xPressed:event.xmotion.x;
  int tmpTop=(yPressed<event.xmotion.y)?yPressed:event.xmotion.y;
  unsigned int tmpWidth=abs (xPressed-event.xmotion.x)+1;
  unsigned int tmpHeight=abs (yPressed-event.xmotion.y)+1;
  XDrawRectangle (display,window,lineGc,
		  tmpLeft,tmpTop,tmpWidth,tmpHeight);

  /////////////////$B<!2s>C$90Y$K:#IA$$$?D9J}7A$r3P$($F$*$/(B
  isRectangleDrawed=True;
  oldLeft=tmpLeft;
  oldTop=tmpTop;
  oldWidth=tmpWidth;
  oldHeight=tmpHeight;
  XFlush (display);
}

void CopyImage2Root::whenButtonReleased (XEvent& event)
{
  isButton1Pressed=False;

  /////////root window$B$KIA2h$9$k(B
  ////window$B$N$I$3$NItJ,$r(Bcopy$B$9$k$+<hF@(B
  int tmpLeft=(xPressed<event.xbutton.x)?xPressed:event.xbutton.x;
  int tmpTop=(yPressed<event.xbutton.y)?yPressed:event.xbutton.y;
  int tmpWidth=abs (xPressed-event.xbutton.x)+1;
  int tmpHeight=abs (yPressed-event.xbutton.y)+1;
  Pixmap bgpixmap=XCreatePixmap (display,window,
				 tmpWidth,tmpHeight,depth);

  ////$BOH$ND9J}7A$r>C$9(B
  XDrawRectangle (display,window,lineGc,
		  oldLeft,oldTop,oldWidth,oldHeight);
  isRectangleDrawed=False;

  /////pixmap$B$K(Bcopy$B$9$k(B
  //  XCopyArea (display,window,bgpixmap,gc,
  //	     tmpLeft,tmpTop,tmpWidth,tmpHeight,0,0);
  XCopyArea (display,window,bgpixmap,gc,
	     tmpLeft,tmpTop,tmpWidth,tmpHeight,0,0);

  ///root window$B$K(Bbackground$B$H$7$F@_Dj$9$k!#(B
  XSetWindowBackgroundPixmap (display,RootWindow (display,screen),
			      bgpixmap);
  XClearWindow (display,RootWindow (display,screen));
  XFreePixmap (display,bgpixmap);
  XFlush (display);
}

void CopyImage2Root::whenKeyPressed ()
{
  if (isRectangleDrawed)
    {////$BOH$ND9J}7A$r>C$9(B
      XDrawRectangle (display,window,lineGc,
		      oldLeft,oldTop,oldWidth,oldHeight);
    }
  isRectangleDrawed=False;
}

void CopyImage2Root::whenDefault ()
{
  if (isRectangleDrawed)
    {////$BOH$ND9J}7A$r>C$9(B
      XDrawRectangle (display,window,lineGc,
		      oldLeft,oldTop,oldWidth,oldHeight);
      isRectangleDrawed=False;
    }
  isRectangleDrawed=False;
  XFlush (display);
}
