/* 
        DebugMode.h

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <iostream.h>

#ifdef __FreeBSD__
# include <ncurses.h>
#else
# include <curses.h>
#endif

#include "const.h"

#ifdef DEBUG_MODE
#ifndef debug_mode_h
#define debug_mode_h

#define MIN_LINES 10 //
#define MIN_COLS 70 //̤size꾮ä齪λ
#define PARAMWINDOW_LINES 5 //paramWindowline
#define LEFT_PADDING 2 //scenarioWindowǺspace礭
#define VARWINDOW_LINES 3//varWindowline

#ifndef CTRL
#define CTRL(c) ((c) & 037) //ɤƤɤΤΤʤ
#endif

class DebugMode
{
protected:
  //////////////////////debug modeɽterminalФƤΤΡ
  char* tty;
  FILE* termFd;
  SCREEN* terminal;
  
  ////////////////////////windowط
  const char* const scenarioTop;//scenarioƬؤ
  const unsigned int scenarioLength;//scenarioĹ
  const int* const intVar;//ѿƬؤ
  WINDOW* scenarioWindow;//scenarioɽwindow
  int scenarioWindowLines;
  int scenarioWindowCols;
  ////scenario Windowμ¹ԤƤԤɽ֤׻뤿ΤΡ
  const char* oldPointer;//ɽ֤ФƤ
  int diffLineOffset;//ɤ줿ФƤ
  
  WINDOW* varWindow;//ѿɽwindow
  int varWindowLines;
  int varWindowCols;

  WINDOW* paramWindow;
  int paramWindowLines;
  int paramWindowCols;

  const char* searchBeginningOfLine (const char* const pt,int n) const;
  //nԲƬ֤n<0λ롣n=0λϸߤιԤƬ֤
  int getAfterLength (const char* const pt) const;
  //ptΰ֤Ԥޤǲͭ뤫֤ߤΰ֤롣
  //ĤޤꡢptԤκǸʸؤƤ1֤
  //ޤ'\r'or '\n'ä顢0֤
  //2byte ʸ2Ȥ롣
  int getBeforeLength (const char* const pt) const;
  //ߤΰ֤βԤޤǲͭ뤫롣
  //ptƬͭ0֤
  //'\r'or'\n'1ȿޤ
 int countBetweenLines
  (const char* const beforePointer,const char* const nowPointer) const;
  //beforePointernowPointerδ֤ˤԤο롣
  //beforePonter<nowPoiterΤȤο֤
  
  void printScenario (const char* const nowPtr,const int lineOffset=0);
  //scenarioWindow򤹤
  void printVar ();//varWindow򤹤
  virtual void printParam ()=0;//paramWindow򤹤롣
  int offset;//ֹ椫ѿɽ
  
  static const char arrow[];//="->";

  Bool isBreakMode;//1command keyԤ򤹤뤫ݤ
  //=True: =False:ʤ

  void initializeScreen ();//terminal롣
  void initializeWindow (WINDOW* window);//windowν򤹤
  void endScreen ();//ncursesθҤ
  void windowSizeChange (const char* const pt);//terminalsizeѹ
  

  DebugMode (const char* const scenarioStart,const int scenarioLength,
	     const int* const intVar,const Bool isBreakMode=False,
	     const char* const maslTty=NULL);
  //Mms::preparePlay ()Ǽ¹
public:
  virtual ~DebugMode ();//Mms::afterPlay ()Ǽ¹
  void printData(const char* const pt);//ǡ߼¹scenariodataɽ롣
  void updataParam (){printParam ();printVar ();refresh ();};
};
#endif//debug_mode_h
#endif//DEBUG_MODE
