/* 
        MaslAudioMix.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/

#include <signal.h>
//#include <csignal>
#include <string.h>
//#include <cstring>

#include "MaslAudio.h"
#include "audio.h"

unsigned char* MaslAudio::isAudioWriting=NULL;//write٤PCM dataͭ뤫
//(ʤBoolͤ8ޤǤʤ餽줾bitɽ)
/* *isAudioWriting!=0 */
unsigned char* MaslAudio::isAudioWaiting=NULL;//PCMκλԤ򤷤Ƥ뤫
/* *isAudioWaiting!=0λԤ򤷤Ƥ롣*/
unsigned long MaslAudio::wroteDataSize[MAX_CHANNEL];//ǡ̤ФƤ
SAMPLE_DATA MaslAudio::sampleData[MAX_CHANNEL];//PCMdata
SAMPLE_DATA MaslAudio::oldSampleData[MAX_CHANNEL];//PCMdataκǽФƤ
  //sampleData.size=-1λƤʤ
//long MaslAudio::sampleRate;//PCMκrate
SAMPLE_DATA MaslAudio::queSampleData[MAX_CHANNEL];//PCMdataκǽФƤ
  //queSampleData.data=NULL,queSampleData.size=-1λԤäƤdata̵

int MaslAudio::fragmentSize;//audio bufferfragment size
timeval MaslAudio::intervalOfWritingAudioData;//PCM񤭹ߤλֳִ

int* MaslAudio::mixedSound=NULL;//datamixing
unsigned char* MaslAudio::writableData=NULL;//mixedSoundclippingƤΥǡclass audioϤ

struct sigaction MaslAudio::sigAction;//signal handler
sigset_t MaslAudio::blockMask;

//sample rateѹ餳methodoɬƤӽФ
//classȤ٤򤹤
void MaslAudio::prepareMaslAudio (unsigned char* const mmsIsAudioWriting,
				  unsigned char* const mmsIsAudioWaiting)
{
  isAudioWriting=mmsIsAudioWriting;
  isAudioWaiting=mmsIsAudioWaiting;
  resetAudioVariable ();
  resetQueData ();
  //(ɬפʤfragmentsizeꤷ)

  //fragmentosizeƲ֤write()٤롣
  //(sampling rateɬ)
  fragmentSize=Audio::getFragmentSize ();
  int sampleRate=Audio::getSampleRate ();
  assert (sampleRate>0);

#if defined (SURROUND)
  // *2ʤΤsurroundϥƥ쥪Ǻ뤫֤ȾʬˤʤΤǡ
  intervalOfWritingAudioData.tv_sec=(long)fragmentSize/(long)(sampleRate*2);
  intervalOfWritingAudioData.tv_usec=
    ((fragmentSize-intervalOfWritingAudioData.tv_sec*(sampleRate*2))
     *((1000000L/(sampleRate*2)-1)));
#else
  intervalOfWritingAudioData.tv_sec=(long)fragmentSize/(long)sampleRate;
  intervalOfWritingAudioData.tv_usec=
    ((fragmentSize-intervalOfWritingAudioData.tv_sec*sampleRate)
     *((1000000L/sampleRate-1)));
#endif

  ////////////////////////////////////////////////signalϢν
  sigAction.sa_handler=writeAudioData;
#ifdef SA_RESTART
  sigAction.sa_flags=SA_RESTART;//this is NOT portable
#else
  sigAction.sa_flags=0;
#endif
  sigemptyset (&blockMask);
  sigaddset (&blockMask,SIGALRM);

  //////////////////////////mixingɬפʪν
  delete [] mixedSound;
  mixedSound=new int[fragmentSize];
  delete[] writableData;
  writableData=new unsigned char[fragmentSize];
}

//!!!!!!!!!!!!!!!note!!!!!!!!!!!!!!!!!!!!!!
//ϥʥ֥åƤʤΤ,
//νκ˥ʥ뤬ưʤʤ롣
//ƤӽФ¦ǥ֥å٤
int MaslAudio::lookForChannel ()
{
  //cerr << "called look for channel" << endl;
  ///Ƥchannelõ
  for (int channel=0;channel<MAX_CHANNEL;channel++)
    {
      if (((*isAudioWriting)&(1 << channel))==0)
	return channel;//ƤchannelĤä
    }

  //cerr << "all channel used." << endl;
#if 0
  for (int channel=MAX_CHANNEL-1;channel>=0;channel--)
    {
      if (sampleData[channel].isLoop==False)
	return channel;
    }

  return MAX_CHANNEL-1;
#endif //#if 0

  //channelɤäƤ
  //äưĹͥɤǤʪȤ
  //٤ϥ롼פƤʤȤͥ衣
  int channel=-1;
  int loopedChannel=-1;
  unsigned long maxSize=0;
  unsigned long maxLoopedSize=0;
  //for (int i=0;i<MAX_CHANNEL;i++)
  for (int i=MAX_CHANNEL-1;i>=0;i--)
    {
      //cerr << "testing isLoop channel=" << i << endl;
      //cerr << i << "-channel ";
      //cerr << "wroteDataSize=" << wroteDataSize[i] << endl;
      if (sampleData[i].isLoop==True)
	{
	  if (maxLoopedSize<wroteDataSize[i])
	    {
	      loopedChannel=i;
	      maxLoopedSize=wroteDataSize[i];
	    }
	}
      else
	{
	  if (maxSize<wroteDataSize[i])
	    {
	      channel=i;
	      maxSize=wroteDataSize[i];
	    }
	}
    }
  //cerr << ":channel=" << channel;
  //cerr << "loopedChannel=" << loopedChannel << endl;
  return (channel==-1)? loopedChannel:channel;
}

void MaslAudio::playAudio(const SAMPLE_DATA pcmData,int channel=-1)
{
  sigprocmask (SIG_BLOCK,&blockMask,NULL);

  //////channel=-1λϤɤchannelǺ뤫ưꡣ
  if (channel==-1)
    channel=lookForChannel ();
  
  //cerr << "settting channel=" << channel << endl;
  //ǡꡣ
  oldSampleData[channel].data=sampleData[channel].data=pcmData.data;
  oldSampleData[channel].size=sampleData[channel].size=pcmData.size;
  oldSampleData[channel].isLoop=sampleData[channel].isLoop=pcmData.isLoop;
  wroteDataSize[channel]=0;
  
  // *isAudioWriting!=0ʤ¾ΥǡǥޡߤäƤ
  //ΤǤˤޤ롣ʤХޡߤ򤫤롣
  if (*isAudioWriting==0)
    {
      //writeAudioData (SIGALRM);
      //writeAudioData (SIGALRM);
      //writeAudioData (SIGALRM);
      setAudioTimerOn();
      raise (SIGALRM);
    }
  *isAudioWriting|=(1 << channel);

  sigprocmask (SIG_UNBLOCK,&blockMask,NULL);
}

//ˤPCMκϤޤ롣
void MaslAudio::setAudioTimerOn()
{
  //ä֤(prepareMaslAudio()Ƿ)audio(write)
  //methodƤӽФ褦signalꤹ롣
  sigaction (SIGALRM,&sigAction,NULL);
  itimerval itval;
  itval.it_value.tv_sec=itval.it_interval.tv_sec=
    intervalOfWritingAudioData.tv_sec;
  itval.it_value.tv_usec=itval.it_interval.tv_usec=
    intervalOfWritingAudioData.tv_usec;
  setitimer (ITIMER_REAL,&itval,NULL);
}

//audiodevicecloseǤƤӽФɬפͭ롣
void MaslAudio::offAudioTimer()
{
  //ŪˤsignalθƤӽФoffˤ
  itimerval itval;
  itval.it_interval.tv_sec=itval.it_interval.tv_usec=0;
  itval.it_value.tv_sec=itval.it_value.tv_usec=0;
  setitimer (ITIMER_REAL,&itval,NULL);
}

//ºݤPCMmethod
//ƤӽФ줿顢ݤƤbufferdatacopyAudio::play()롣
//write()sizemin(fragment size,dataλĤsize)
//fragmentsizeͤ꾮ͤwrite()Audio::post()
void MaslAudio::writeAudioData(int sig)
{
  int numOfData=0;//ºݤͭʥǡο
  for (int i=0;i<MAX_CHANNEL;i++)
    {
      if (sampleData[i].data!=NULL)
	numOfData++;
    }
  if (numOfData==0)
    {//writedata̵Τǡ⤻롣
      *isAudioWriting=0;
      offAudioTimer ();
      return;
    }

  if (getNoBlockingSize ()<fragmentSize)
    return;//datawrite褦ȤblockΤǲ⤻롣

  /////////////////////////////////////////////////////mixing
  memset (mixedSound,0,fragmentSize*sizeof (int));
  for (int chan=0;chan<MAX_CHANNEL;chan++)
    {
      if (sampleData[chan].data==NULL)
	continue;//ΥͥϺƤʤΤФ

      //cerr << "now mixing channel=" << chan;
      //cerr << ":size=" << sampleData[chan].size;
      //cerr << ":wroteDataSize[channel]=" << wroteDataSize[chan] << endl;
      int tmpSize=0;
      while (tmpSize<fragmentSize)
	{
	  if (tmpSize+sampleData[chan].size<fragmentSize)
	    {
	      for (int i=0;i<sampleData[chan].size;i++)
		mixedSound[tmpSize+i]+=sampleData[chan].data[i]-0x80;
	      tmpSize+=sampleData[chan].size;
	      wroteDataSize[chan]+=sampleData[chan].size;
	      
	      if (queSampleData[chan].data!=NULL)
		{//ԤäƤdataͭäΤǤΥǡ롣
		  oldSampleData[chan].data=sampleData[chan].data=queSampleData[chan].data;
		  oldSampleData[chan].size=sampleData[chan].size=queSampleData[chan].size;
		  oldSampleData[chan].isLoop=sampleData[chan].isLoop=queSampleData[chan].isLoop;
		  wroteDataSize[chan]=0;
		  queSampleData[chan].data=NULL;
		  queSampleData[chan].size=-1;
		  queSampleData[chan].isLoop=False;
		  continue;
		}
	      if (sampleData[chan].isLoop)
		{//loopΤǥǡƬ롣
		  sampleData[chan].data=oldSampleData[chan].data;
		  sampleData[chan].size=oldSampleData[chan].size;
		  continue;
		}

	      //⤦write٤ǡĤäƤʤ
	      *isAudioWriting &=~(1 << chan);
	      oldSampleData[chan].data=sampleData[chan].data=NULL;
	      oldSampleData[chan].size=sampleData[chan].size=-1;
	      oldSampleData[chan].isLoop=sampleData[chan].isLoop=False;
	      wroteDataSize[chan]=0;
	      break;
	    }
	  else
	    {//dataޤǤwriteʤ
	      for (int i=0;i<fragmentSize-tmpSize;i++)
		mixedSound[tmpSize+i]+=sampleData[chan].data[i]-0x80;
	      sampleData[chan].data+=fragmentSize-tmpSize;
	      sampleData[chan].size-=fragmentSize-tmpSize;
	      wroteDataSize[chan]+=fragmentSize-tmpSize;
	      break;
	    }
	}
    }

  /////////////////////////////////////////////////////clipping
  for (int i=0;i<fragmentSize;i++)
    {
      mixedSound[i]+=128;
      if (mixedSound[i]>255)mixedSound[i]=255;
      if (mixedSound[i]<0)mixedSound[i]=0;
    }
  for (int i=0;i<fragmentSize;i++)
    writableData[i]=mixedSound[i];
  
  /////////////////////////////////////////////////////write data
  Audio::play (writableData,fragmentSize);

  /////////////////////////////////////////////////////clean up
  if (*isAudioWriting==0)
    {
      //Audio::post ();
      offAudioTimer ();
    }
}


Bool MaslAudio::setSampleRate(const long rate)
{
  offAudioTimer ();
  resetAudioVariable ();
  resetQueData ();
  
  int sampleRate=rate;
  Bool tmp=Audio::setRate (sampleRate);
  if (tmp)
    {//rate
      prepareMaslAudio (isAudioWriting,isAudioWaiting);
      return True;
    }
  else
    {
      return False;//rate˼Ԥ
    }
}


void MaslAudio::stopAudio (const int channelMask)
{
  sigprocmask (SIG_BLOCK,&blockMask,NULL);
  
  for (int i=0;i<MAX_CHANNEL;i++)
    {
      if (channelMask&(1 << i)==0) continue;//Υͥϻߤʤ
      oldSampleData[i].data=sampleData[i].data=queSampleData[i].data=NULL;
      oldSampleData[i].size=sampleData[i].size=queSampleData[i].size=-1;
      oldSampleData[i].isLoop=sampleData[i].isLoop=queSampleData[i].isLoop=False;
      wroteDataSize[i]=0;
    }
  sigprocmask (SIG_UNBLOCK,&blockMask,NULL);
}

//Audio::reset()ƤӽФƤϼ֤
void MaslAudio::resetAudio()
{//ߤ롣ΤˤϺʪλ
  offAudioTimer ();
  int sampleRate=Audio::getSampleRate ();
  Audio::resetAudioDevice ();
  Audio::initializeAudioDevice (sampleRate);
  resetAudioVariable ();
  resetQueData ();
}

void MaslAudio::resetAudioVariable()
{
  //ѿν
  for (int i=0;i<MAX_CHANNEL;i++)
    {
      oldSampleData[i].data=sampleData[i].data=NULL;
      oldSampleData[i].size=sampleData[i].size=-1;
      oldSampleData[i].isLoop=sampleData[i].isLoop=False;
      wroteDataSize[i]=0;
    }
  *isAudioWriting=0;
  *isAudioWaiting=0;
}

//////////////////////////////////////////////////Queط
void MaslAudio::queAudioData (const SAMPLE_DATA pcmData,int channel=-1)
{
  sigprocmask (SIG_BLOCK,&blockMask,NULL);
  
  if (channel==-1)
    channel=lookForChannel ();
  queSampleData[channel].data=pcmData.data;
  queSampleData[channel].size=pcmData.size;
  queSampleData[channel].isLoop=pcmData.isLoop;
  
  sigprocmask (SIG_UNBLOCK,&blockMask,NULL);
}

void MaslAudio::resetQueData ()
{
  for (int i=0;i<MAX_CHANNEL;i++)
    {
      queSampleData[i].data=NULL;
      queSampleData[i].size=-1;
      queSampleData[i].isLoop=False;
    }
}
