/* 
        MaslDebugMode.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/


#include "Masl.h"
#include "MaslDebugMode.h"
#ifdef DEBUG_MODE

Masl::MaslDebugMode::MaslDebugMode (const Masl* const masl,
				    const char* const scenarioStart,
				    const int scenarioLength,
				    const int* const intVar,
				    Bool isBreakMode=False,
				    const char* const maslTty=NULL):
  DebugMode (scenarioStart,scenarioLength,intVar,isBreakMode,maslTty),
  masl (masl)
{
  initializeScreen ();
}

Masl::MaslDebugMode::~MaslDebugMode ()
{
  // do nothing
}

void Masl::MaslDebugMode::printParam ()
{
  werase (paramWindow);
  wmove (paramWindow,1,1);
  wprintw (paramWindow,
	   "showPage=%d,drawPage=%d,",
	   masl->getShowPage (),masl->getDrawPage ());

  wprintw (paramWindow,
	   "aheadCell=%3d,"
	   "is200lineMode=%d,",
	   masl->getAheadlyExtractedCellNumber (),
	   masl->getIs200LineMode ());

  wprintw (paramWindow,
	   "cells=%d,pallets=%d,Pcm=%d\n ",
	   masl->getNumberOfCells (),masl->getNumberOfPalettes (),
	   masl->getNumberOfPcm ());

  RECT rect=masl->getViewPort ();
  wprintw (paramWindow,
	   "mask=(%3d,%3d)-(%3d,%3d),",
	   rect.left,rect.top,rect.right,rect.bottom);
  wprintw (paramWindow,
	   "curPalette=%3d,"
	   "gdcRoll=%5d,gdcLoop=%d\n ",
	   masl->getCurrentPaletteNumber (),masl->getVramOrg (),
	   masl->getGDCLoopLength ());

  wprintw (paramWindow,
	   "time=%4d,waitFor=%4d(%4d/100Hz),"
	   "rate=%5dHz,"
	   "isAudioWriting=%d\n ",
	   masl->getNowCount (),
	   masl->getTimeCntForWait (),
	   masl->getTimeCounter (),
	   Audio::getSampleRate (),
	   masl->getIsAudioWriting ());

  box (paramWindow,0,0);
  mvwaddstr (paramWindow,0,LEFT_PADDING,"xmasl:debug mode");

  wnoutrefresh (paramWindow);
}
#endif //DEBUG_MODE
