/* 
        palette.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	shimarincode򸵤Yamahata񤤤ʪǤ
*/
#include "MaslConst.h"
#include "Palette.h"

Display* Palette::display;
Colormap Palette::colormap;
unsigned long Palette::palette2Pixel[NUMBER_OF_COLORS];
PALETTE Palette::paletteOfNow[NUMBER_OF_COLORS];

Palette::Palette (MaslInputStream& maslIs)
{
  //fread (fileName,1,16,fp);//file nameɤߤ
  maslIs.read (fileName,16);
  fileName[16]='\0';

  unsigned char buffer[NUMBER_OF_COLORS*3];//dataɤ߹Ѥbuffer
  maslIs.read (buffer,sizeof (buffer));//dataɤ߹
  int c=0;
  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {//palette
      palette[i].r=buffer[c];
      c++;
      palette[i].g=buffer[c];
      c++;
      palette[i].b=buffer[c];
      c++;
    }
}

Palette::~Palette ()
{
}

void Palette::preparePalette (Display* const maslDisplay,
			      const Colormap maslColormap,
			      const unsigned long planes[DEPTHOFAK5],
			      const unsigned long basePixel)
{
  display=maslDisplay;
  colormap=maslColormap;
  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {
      palette2Pixel[i]=
	basePixel|
	((i&1)?planes[0]:0)|
	((i&2)?planes[1]:0)|
	((i&4)?planes[2]:0)|
	((i&8)?planes[3]:0);
    }
}

void Palette::setPalette (int contrast=100)
{
  assert (0<=contrast && contrast<=100);
  
  XColor xcolor[NUMBER_OF_COLORS];
  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {
      const int r=palette[i].r;
      const int g=palette[i].g;
      const int b=palette[i].b;
      
      paletteOfNow[i].r=r;
      paletteOfNow[i].g=g;
      paletteOfNow[i].b=b;
      setXColor (xcolor[i],i,r,g,b,contrast);
    }
  XStoreColors (display,colormap,xcolor,NUMBER_OF_COLORS);
}

void Palette::setPalette (const int paletteNumber,
			  const int r,const int g,const int b,
			  const int contrast=100)
{
  assert (0<=contrast && contrast <=100);
  paletteOfNow[paletteNumber].r=r;
  paletteOfNow[paletteNumber].g=g;
  paletteOfNow[paletteNumber].b=b;

  XColor xcolor;
  setXColor (xcolor,paletteNumber,r,g,b,contrast);
  XStoreColor (display,colormap,&xcolor);
}

void Palette::setTone (const int contrast)
{
  XColor xcolor[NUMBER_OF_COLORS];
  for (int i=0;i<NUMBER_OF_COLORS;i++)
    {
      setXColor (xcolor[i],i,
		 paletteOfNow[i].r,paletteOfNow[i].g,paletteOfNow[i].b,
		 contrast);
    }
  
  XStoreColors (display,colormap,xcolor,NUMBER_OF_COLORS);
}

void Palette::mix (const int paletteNumber1,const int paletteNumber2,
		   const int ratio,const int contrast=100)
{
  assert (0<=ratio);
  assert (ratio<=100);

  const int r1=paletteOfNow[paletteNumber1].r;
  const int g1=paletteOfNow[paletteNumber1].g;
  const int b1=paletteOfNow[paletteNumber1].b;
  const int r2=paletteOfNow[paletteNumber2].r;
  const int g2=paletteOfNow[paletteNumber2].g;
  const int b2=paletteOfNow[paletteNumber2].b;
  
  setPalette (paletteNumber1,
	      (r1*ratio+r2*(100-ratio))/100,
	      (g1*ratio+g2*(100-ratio))/100,
	      (b1*ratio+b2*(100-ratio))/100,
	      contrast);
  setPalette (paletteNumber2,
	      (r1*(100-ratio)+r2*ratio)/100,
	      (g1*(100-ratio)+g2*ratio)/100,
	      (b1*(100-ratio)+b2*ratio)/100,
	      contrast);
}
