/* 
        Pcm.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        codeshimarincode򸵤YamahataʪǤ

	Open Sound System verion Copyright (c)1997 Yamahata Isaku (ISA-9)
        Sun OS 4 version Copyright (c) 1997   (hibi@is.s.u-tokyo.ac.jp)
*/
#include "audio.h"
#include "MaslAudio.h"
#include "Pcm.h"

Pcm::Pcm (unsigned char mmsType,MaslInputStream& maslIs):
  type (mmsType)
{
  //file name ɤ߹
  maslIs.read (fileName,16);
  fileName[16]='\0';

/*
#ifdef DEBUG
  cout << "Pcm file name =" << fileName << endl;
#endif
*/

  //Pcm rateɤ߹
  PcmRate=maslIs.get16 ();

/*
#ifdef DEBUG
  cout << "Pcm rate=" << PcmRate << endl;
#endif
*/

  //Pcm datasizeɤߤ
  sizeOfAdpcm=maslIs.get32 ();
  
/*
#ifdef DEBUG
  cout << "Pcm sizeOfAdpcm=" << sizeOfAdpcm << endl;
#endif
*/

  adpcmData=new unsigned char[sizeOfAdpcm];
  maslIs.read (adpcmData,sizeOfAdpcm);
  adpcm2U8 ();//unsigned linear 8bitѴ

#if defined (SURROUND) && !defined (NAS)
  convertSurround ();
#endif

#if defined ULAW
  U82ulaw ();
#elif defined(LINEAR8)||defined(LINEAR16) 
  U82linear ();
#endif //defined ULAW
}

#if defined (SURROUND) && !defined (NAS)
//surroundˤʤ褦˥ǡѴ
void Pcm::convertSurround ()
{
  unsigned char* surroundData=new unsigned char[sizeOfU8*2];
  /// *2ϥƥ쥪ˤʤ뤫顣
  for (unsigned int i=0;i<sizeOfU8;i++)
    {
      surroundData[i*2]=u8Data[i];

      //singed linearž롣ǡ8bit-128127ʤΤ
      //ФƤͤ-127128ä128clippingɬפ롣
      //unsigned linear 8bit0255
      int tmp=(-((int) u8Data[i]-0x80))+0x80;
      surroundData[i*2+1]=(tmp>0xff)?0xff:tmp;
    }
  delete[] u8Data;
  u8Data=surroundData;
  sizeOfU8*=2;
}
#endif

Pcm::~Pcm ()
{
  delete[] adpcmData;
  delete[] u8Data;
}


void Pcm::play ()
{
#ifdef NAS
  Audio::play (u8Data,sizeOfU8,False);
#else
  Audio::play (u8Data,sizeOfU8);
#endif
}


//channel=-1λchannelưꡣ
void Pcm::play (const int channel,const Bool isLoop=False)
{
  assert (-1<=channel);
  assert (channel<8);
  SAMPLE_DATA pcmData;
  pcmData.data=u8Data;
  pcmData.size=sizeOfU8;
  pcmData.isLoop=isLoop;
  MaslAudio::playAudio (pcmData,channel);
}

void Pcm::que (const int channel,const Bool isLoop)
{
  SAMPLE_DATA pcmData;
  pcmData.data=u8Data;
  pcmData.size=sizeOfU8;
  pcmData.isLoop=isLoop;
  MaslAudio::queAudioData (pcmData,channel);
}


void Pcm::adpcm2U8 ()
{
  //adpcmData(IMA ADPCM 4bit)linear unsigned 8bit formatѴ롣
  //ǤɤäɤΤΤʤ(^^;;
  //ǡsizeOfU8롣
  sizeOfU8=((type==1||type==3)?sizeOfAdpcm*2:sizeOfAdpcm);
  u8Data=new unsigned char[sizeOfU8];
  
  if (type==1||type==3)
    {
      now=0x7ff;
      adp=0;
      //кtableκ
      long l,p;
      l=p=1L;
      for (short i=0;i<ADPTABLESIZE;i++)
	{
	  adp_table[i]=(short) (l*16/p);
	  l*=11L;
	  p*=10L;
	  if (p>100000L)//ͭ5ͭнʬ
	    {
	      l/=10L;
	      p/=10L;
	    }
	}
     
      //inprtADPCM datalinear PCMȤoutptrȤƽ
      unsigned char* outptr=u8Data;
      unsigned char* inptr=adpcmData;
      for (unsigned int j=0;j<sizeOfAdpcm;j++)
	{
	  //4bit
	  unsigned char data=(*inptr)&0x0f;
	  calcSub (data);
	  *outptr= (unsigned char) ((now>>4)&0xff);//12bit PCM -> 8bit PCM
	  outptr++;

	  //4bit
	  data=((*inptr)&0xf0)>>4;
	  calcSub (data);
	  *outptr= (unsigned char) ((now>>4)&0xff);//12bit PCM -> 8bit PCM
	  outptr++;
	  
	  inptr++;
	}

    }//if

  if (type!=1&&type!=3)
    {//signed linear 8bitäΤǡunsigned linear 8bitѴ
     //127­Ф褤
      for (unsigned int dw=0;dw<sizeOfAdpcm;dw++)
	{
	  u8Data[dw]=adpcmData[dw]^0x80;
	}
    }
  
  //פˤʤäʪϽʬ
  delete[] adpcmData;
  adpcmData=NULL;
}

void Pcm::calcSub (unsigned char data)
{
  const short step_table[16]=
  {
    -1,-1,-1,-1,2,4,6,8,
    -1,-1,-1,-1,2,4,6,8
  };

  short flag;
  short del_t;
  
  del_t=adp_table[adp];
  flag=((data&0x08)==0)?1:-1;
  
  now+=flag*del_t/8;
  if (data&1) now+=flag*del_t/4;
  if (data&2) now+=flag*del_t/2;
  if (data&4) now+=flag*del_t;
  if (now>0x0fff) now=0x0fff;
  if (now <0)     now=0;
  adp+=step_table[data];
  if (adp>=ADPTABLESIZE) adp=ADPTABLESIZE-1;
  if (adp<0)             adp=0;

}

#if defined ULAW
unsigned char  Pcm::st_linear_to_ulaw( int  sample )
{
  const int  bias = 0x84;
  const int  clip = 32635;
  static int exp_lut[256] = {0,0,1,1,2,2,2,2,3,3,3,3,3,3,3,3,
			     4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
			     5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
			     5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
			     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
			     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
			     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
			     6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
			     7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7};
  int sign, exponent, mantissa;
  unsigned char ulawbyte;

  /* Get the sample into sign-magnitude. */
  sign = (sample >> 8) & 0x80;		/* set aside the sign */
  if ( sign != 0 ) sample = -sample;		/* get magnitude */
  if ( sample > clip ) sample = clip;		/* clip the magnitude */

  /* Convert from 16 bit linear to ulaw. */
  sample = sample + bias;
  exponent = exp_lut[( sample >> 7 ) & 0xFF];
  mantissa = ( sample >> ( exponent + 3 ) ) & 0x0F;
  ulawbyte = ~ ( sign | ( exponent << 4 ) | mantissa );

  if ( ulawbyte == 0 ) ulawbyte = 0x02;	/* optional CCITT trap */

  return ulawbyte;
}

void Pcm::U82ulaw ()
{
  const int  lawh = 8000;

  delete[] adpcmData;
  adpcmData = NULL;

  int  sampleRate = PcmRate;
  double  d = (double)sampleRate / (double)lawh;
  // printf ("d = %f\n", d);
  int  i = 0;
  for ( double  sum = 0; sum < sizeOfU8; sum += d, i++ )
    {
      int  datum;
      datum = (u8Data[(int)sum] ^ 128) << 8;
      u8Data[i] = st_linear_to_ulaw(datum);
    }
  sizeOfU8 = (int)(sizeOfU8 / d);

#if 0
  for ( int  i = 0; i < size; i++)
    {
      int  datum;
      datum = (u8Data[i] ^ 128) << 8;
      pcmData[i] = st_linear_to_ulaw(datum);
    }
#endif
}
#elif defined LINEAR8
void Pcm::U82linear ()
{
  const int  lawh = 8000;

  delete[] adpcmData;
  adpcmData = NULL;

  int  sampleRate = PCMRate;
  double  d = (double)sampleRate / (double)lawh;
  // printf ("d = %f\n", d);
  int  i = 0;
  for ( double  sum = 0; sum < sizeOfU8; sum += d, i++ )
    {
      u8Data[i] = (u8Data[(int)sum] ^ 128) << 8;
    }
  sizeOfU8 = (int)(sizeOfU8 / d);

  unsigned char *  tmpData = new unsigned char[sizeOfU8];
  for ( int  i = 0; i < sizeOfU8; i++ )
    {
      tmpData[i] = u8Data[i];
    }
  delete[] u8Data;
  u8Data = new unsigned char[sizeOfU8 * 2];
  for ( int  i = 0; i < sizeOfU8; i++ )
    {
      u8Data[2*i] = tmpData[i];
      u8Data[2*i+1] = 0;
//       linerData[2*i+1] = (u8Data[i] ^ 128);
//       linerData[2*i] = 0;
    }
  delete [] tmpData;
}
#elif defined LINEAR16
void Pcm::U82linear ()
{
  delete[] adpcmData;
  adpcmData = NULL;

  // printf ("d = %f\n", d);
// 					datum ^= 128;
// 					/* scale signed up to long's range */
// 					*buf++ = LEFT(datum, 24);
// 					datum = RIGHT(*buf++, 16);
// 					wshort(ft, datum);
  unsigned char *  tmpData = new unsigned char[sizeOfU8];
  for ( int  i = 0; i < sizeOfU8; i++ )
    {
      tmpData[i] = u8Data[i];
    }
  delete[] u8Data;
  u8Data = new unsigned char[sizeOfU8 * 2];
  for ( int  i = 0; i < sizeOfU8; i++ )
    {
      u8Data[2*i] = (tmpData[i] ^ 128);
      u8Data[2*i+1] = 0;
//       linerData[2*i+1] = (u8Data[i] ^ 128);
//       linerData[2*i] = 0;
    }
  delete [] tmpData;
  // PcmRate = 16000;
}
#endif //define ULAW
