/* 
        Scenario.cc

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        $B$3$N(Bcode$B$O(Bshimarin$B$5$s$N(Bcode$B$r85$K(BYamahata$B$,=q$-D>$7$?J*$G$9!#(B
        sjis->euc$B$NJQ49ItJ,$OGr0f(B $BN4(B(shirai@nintendo.co.jp)$B$5$s$N(BFD-clone$B$N(B
        code$B$r;H$o$;$FD:$-$^$7$?!#(B
        >$B!!(BFDclone $B$NCx:n8"$O!"(B[ $BGr0f(B $BN4(B <shirai@red.nintendo.co.jp> ]
        >$B$,J];}$7$^$9!#C"$7!"A4$F$N%=!<%9$NG[I[!"2~JQ!"0zMQ!"(B2 $B<!MxMQ(B
        >$B$K$D$$$F$O!"2?$iB+G{$5$l$k$3$H$J$/<+M3$K9T$J$C$FD:$$$F9=$$$^(B
        >$B$;$s!#(B
*/
#include <ctype.h>
#include <string.h>

#include "Scenario.h"

Scenario::Scenario (char* filename) :
  scenarioSize (0),ver1 (0),ver2 (0),dataFilename (NULL),reserved (NULL)
{
    //////////////////////////////////////////////////////////file$BFI$_9~$_(B
  MaslInputStream msc (filename,ios::in|ios::nocreate);
  if (!msc)
    {
      cerr << filename << "is not found." << endl;
      msc.close ();
      return;
    }
  
  int scenarioSize=msc.getFileSize ();
  scenarioData=new char[scenarioSize];
  msc.read (scenarioData,scenarioSize);
  msc.close ();
}

  
Scenario::Scenario (MaslInputStream& mmsIs,int ScenarioSize) :
  scenarioSize (ScenarioSize),ver1 (0),ver2 (0),
  dataFilename (NULL),reserved (NULL)
{
  scenarioData=new char[scenarioSize];
  mmsIs.read (scenarioData,scenarioSize);
}

Scenario::Scenario (char* data,int ScenarioSize):
  scenarioSize (ScenarioSize),ver1 (0),ver2 (0),
  dataFilename (NULL),reserved (NULL)
{
  scenarioData=new char[scenarioSize];
  memcpy (scenarioData,data,ScenarioSize);
}

Scenario::~Scenario ()
{
  delete[] scenarioData;
}

const char* const Scenario::getDataFilename ()
{
  if (dataFilename==NULL)//$B$b$&A4ItFI$_=P$7$?(B
    return NULL;
  
#if 0
  /////////////\cg??$B$H(B\pal??$B$K$OBP1~$7$F$$$J$$$N$G$=$l$i$r%9%-%C%W(B
  if (*dataFilename=='\\')
    {
      while (*(dataFilename-2)!='\r' || *(dataFilename-1)!='\n' ||
	     *(dataFilename)=='\\')
	dataFilename++;//$B2~9T$^$GHt$P$9(B
    }
#endif

  char* const tmp=strchr (dataFilename,'\r');
  *tmp='\0';

  //=,|$B$K$OBP1~$7$F$$$J$$$N$G$=$l$i$r%9%-%C%W(B
  while (*dataFilename=='='||*dataFilename=='|')
    {
      dataFilename=strpbrk (dataFilename,":");
      dataFilename++;
    }

  char* ret=dataFilename;
  dataFilename=tmp+2;
  if (*dataFilename=='.')//.$B$N$_$N9T$,Mh$l$P=*$j(B
    dataFilename=NULL;
  
  return ret;
}

const char* const Scenario::getReservedName ()
{
  if (reserved==NULL)//$B$b$&A4ItFI$_=P$7$?(B
    return NULL;
  
  char* tmp=reserved;
  tmp=strchr (reserved,'\r');
  *tmp='\0';
  char* ret=reserved;
  reserved=tmp+2;
  if (*dataFilename=='.')//.$B$N$_$N9T$,Mh$l$P=*$j(B
    dataFilename=NULL;
  
  return ret;
}

int Scenario::searchnum (const char*& tmp)
{
  int ch;//data$BFI$_9~$_MQ(B
  int fg=1;//$BId9g(B
  int i=0;//$B5"$jCM$N@dBPCM(B
  
  tmp=strpbrk (tmp,"-0123456789");
  
  if (*tmp=='-')
    {//$BId9gFI$_9~$_(B
      fg=-1;
      tmp++;
    }

  while (isdigit (ch= (int) (*tmp)))
    {
      if (isdigit (ch))
        {
          i*=10;//$B0l7e7+$j>e$2$F!"(B
          i+=ch-'0';//$B2<0L$K?t;z$NFI$_9~$_(B
        }
      tmp++;
    }
  return fg*i;
}


///////////////////////////////////////////////////comment $BI=<((B
void Scenario::printComment (Bool isSjis)
{
  writeSjis (cout,comment,commentSize,isSjis);
  cout << endl;
}

ostream& Scenario::writeSjis (ostream& outputStream,
			      const char* const sjisData,const int size,
			      const Bool isOutputSjis=False)
//out$B$K(Bwrite$B$9$k!#(BisOutputSjis=False$B$N;~$O(Bsjis$B$r(Beuc$B$KJQ49$9$k!#(B
//                isOutputSjis=True$B$N;~$O$=$N$^$^(B
{
  if (isOutputSjis)
    {//sjis$B$G=PNO(B($B2?$bJQ49$;$:$=$N$^$^=PNO(B)
      outputStream.write (sjisData,size);
    }
  else
    {//euc$B$KJQ49$7$F=PNO(B
      char* eucData=new char[size*2];
      int eucSize=convertSjis2Euc ((unsigned char*) sjisData,size,
				   (unsigned char*) eucData);
      outputStream.write (eucData,eucSize);
      delete[] eucData;
    }
  return outputStream;
}

int Scenario::convertSjis2Euc (const unsigned char* const comment,
			       const int numberOfCharInComment,
			       unsigned char* const eucComment)
{
  int j=0;
  for (int i=0;i<numberOfCharInComment;i++)
    {
      if (comment[i]>=0xa1 && comment[i]<=0xdf)
        {//$BH>3Q2>L>$@$C$?(B
          eucComment[j++]=0x8e;
          eucComment[j++]=comment[i];
        }
      else if ((0x81<=comment[i] && comment[i]<=0x9f)||
               (0xe0<=comment[i] && comment[i]<=0xfc))
        {//2byte code$B$@$C$?!#(B
          eucComment[j++]=comment[i]*2
            -((comment[i]<=0x9f)?0xe1:0x161)+0x80;
          eucComment[j++]=comment[++i];
          if (comment[i]<0x9f)
            eucComment[j-1]+=(comment[i]>0x7f)?0x60:0x61;
          else 
            {
              eucComment[j-1]+=2;
              eucComment[j-2]++;
            }
        }
      else eucComment[j++]=comment[i];//1byte code$B$@$C$?!#(B
    }
  return(j);
}


Bool Scenario::searchNextCommand ()
{//$B<!$NM-8z$J(Btoken$B$,M-$k$^$G!"(Bpt$B$r?J$a$k!#(B
  while ((*pt==':'||*pt==' '||*pt=='\t'||*pt=='\r'||*pt=='\n'||*pt==';')
         &&pt-scenarioData<scenarioSize)
    {//$B6uGr!"2~9T$r$H$P$9!#(B;$B$O%3%a%s%H(B
      if (*pt==';')
        {//$B%3%a%s%H$J$N$G2~9T$^$G$H$P$9!#(B
          pt++;
          while (*(pt-2)!='\r'||*(pt-1)!='\n')
            {
              pt++;
            }
        }
      else
        {
          pt++;
        }
    }

  if (pt-scenarioData>=scenarioSize)
    return False;
  else
    return True;
}
