/* 
        audioSunOs4.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	Sun OS 4 version Copyright (c) 1997   (hibi@is.s.u-tokyo.ac.jp)
*/

#define NOAUDIO_FRAG_SIZE  8192
//ο˿̣ͭޤŬǤ
//ޤưʤʤѤƤߤɤ⡣

Bool Audio::openAudioDevice ()
{
  if (isAudioDisabled)
    return True;
  
  if ((audio=open (SOUND_DEVICE,O_WRONLY|O_NDELAY))==-1)
  //if ((audio=open (SOUND_DEVICE,O_WRONLY))==-1)
    {
      perror ("Can not open audio device.");
      return False;
    }
  //  cerr << "audio device is opened." << endl;
  isDeviceOpened=True;

  // turn NDELAY mode off:
//   int flags;
//   if ((flags = fcntl (audio, F_GETFL, 0)) < 0)
//   {
//     perror ("fcntl F_GETFL on /dev/audio failed");
//     return False;
//   }
//   flags &= ~O_NDELAY;
//   if (fcntl (audio, F_SETFL, flags) < 0)
//   {
//     perror ("fcntl F_SETFL on /dev/audio failed");
//     return False;
//   }

  return True;
}

int Audio::closeAudioDevice ()
{
  if (isAudioDisabled)
    return True;

  Bool tmp=(close (audio)==0);
  if (tmp)
    {//deviceclose褿
      isDeviceOpened=False;
      return tmp;
    }
  else
    {//devicecloseʤä
      perror ("can not close audio device.");
      return tmp;
    }
}

Bool Audio::initializeAudioDevice (const int rate)
{
  if (isAudioDisabled)
    return True;

  if (!(isDeviceOpened))
    {//ޤaudio deviceopenƤʤä
      printErrorDeviceIsNotOpened ();
      return False;
    }
  
  audio_info_t sun_audio_t;  /* all data is in it */
//   if ( ioctl ( audio, AUDIO_GETINFO, &sun_audio_t) != 0 )
//     {
//       perror ("Fail to get current audio infomation!!");
//       return False;
//     }

  AUDIO_INITINFO (&sun_audio_t);

#if defined(ULAW)
  int bitPerSample=8;//8bit
  //   int format=AFMT_U8;//unsigned linear 8bit
  int format=AUDIO_ENCODING_ULAW;//ulaw
  int channel=1;//channel
  sampleRate=8000;
  //   int tmp;
#elif defined(LINEAR8)
  int bitPerSample=16;
  //   int format=AFMT_U8;//unsigned linear 8bit
  int format=AUDIO_ENCODING_LINEAR;//signed linear 8bit
  int channel=2;//channel
  sampleRate=8000;
#elif defined LINEAR16
  int bitPerSample=16;
  //   int format=AFMT_U8;//unsigned linear 8bit
  int format=AUDIO_ENCODING_LINEAR;//signed linear 16bit
  int channel=1;//channel
  sampleRate=16000;
#endif

#if defined(DEBUG)
  printf("sampleRate %d\n", rate);
#endif //defined(DEBUG)

  sun_audio_t.play.sample_rate = sampleRate;
  sun_audio_t.play.channels = channel;
  sun_audio_t.play.precision = bitPerSample;
  sun_audio_t.play.encoding = format;
  sun_audio_t.play.balance = AUDIO_LEFT_BALANCE;

#if defined(DEBUG)
  printf("sampleRate = %d\n", sun_audio_t.play.sample_rate);
  printf("channels = %d\n", sun_audio_t.play.channels);
  printf("precision = %d\n", sun_audio_t.play.precision);
  printf("encoding = %d\n", sun_audio_t.play.encoding);
  printf("balance = %d\n", sun_audio_t.play.balance);
#endif

  if ( ioctl ( audio, AUDIO_SETINFO, &sun_audio_t) != 0 )
    {
      perror ("Fail to set audio infomation!!");
      return False;
    }

#if defined(DEBUG)
  if ( ioctl ( audio, AUDIO_GETINFO, &sun_audio_t) != 0 )
    {
      perror ("Fail to get audio infomation!!");
      return False;
    }

  printf("sampleRate = %d\n", sun_audio_t.play.sample_rate);
  printf("channels = %d\n", sun_audio_t.play.channels);
  printf("precision = %d\n", sun_audio_t.play.precision);
  printf("encoding = %d\n", sun_audio_t.play.encoding);
  printf("balance = %d\n", sun_audio_t.play.balance);
#endif

/*
#ifdef DEBUG
  cerr << "sample rate=" << rate << endl;
#endif
*/
  return True;
}

void Audio::play (const unsigned char* const pcmData,int size)
{
  if (isAudioDisabled)
    return;
  
  write (audio,pcmData,size);
}

void Audio::resetAudioDevice ()
{
  if (isAudioDisabled)
    return;

//    audio_info_t sun_audio_t;  /* all data is in it */
//    if ( ioctl ( audio, AUDIO_GETINFO, &sun_audio_t) != 0)
//      {
//        perror ("Fail to reset!");
//        exit(1);
//      }
//    if ( ioctl ( audio, AUDIO_SETINFO, &sun_audio_t) != 0)
//      {
//        perror ("Fail to reset!");
//        exit(1);
//      }
}

Bool Audio::setRate (const long rate)
{
  //ɽˡϡ'rateP1'
  //εǽ  УãͤΥ졼ȤP1
  //   'rate16540' - 졼Ȥ򣱣ȣ
  //Υޥɤ¹ԤȡȯΣУãͤߤޤ
  if (isAudioDisabled)
    return True;

  resetAudioDevice ();
  if (!(closeAudioDevice ()))
    return False;

  if (!(openAudioDevice ()))
    return False;
    
  return initializeAudioDevice (rate);
}

int Audio::getNoBlockingSize ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE;

  return NOAUDIO_FRAG_SIZE;
}

int Audio::getFragmentSize ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE;

  return NOAUDIO_FRAG_SIZE;
}

int Audio::getSampleRate ()
{
  if (isAudioDisabled)
    return NOAUDIO_FRAG_SIZE*2;
  //*2ȸΤ
  //maslaudio.h maslaudo.cppǤsignal0.5֤ˤʤ褦ˤƤ롣
  //OSSdefaultǤʤ褦ʤΤǡ
  //ޤʤʤͤѤƸɤ⡢

  return sampleRate;
}

void Audio::sync ()
{
  if (isAudioDisabled)
    return;

//   if (ioctl (audio, AUDIO_DRAIN)==-1)
//     {
//       perror ("can not sync audio dev");
//       exit (-1);
//     }
}

void Audio::post ()
{
  if (isAudioDisabled)
    return;
}

void Audio::enableAudio ()
{
  isAudioDisabled=False;
}

void Audio::disableAudio ()
{
  if (isDeviceOpened)
    closeAudioDevice ();
  
  isAudioDisabled=True;
}

Bool Audio::isAudioEnabled ()
{
  return !(isAudioDisabled);
}

void Audio::printErrorDeviceIsNotOpened ()
{
  cerr << "audio device is not opened." << endl;
  cerr << "before using audio,you must open audio device." << endl;
} 
