/* 
        maslplay.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarincode򸵤YamahataľʪǤ
	ޤcommentˤKunimaslֺ(maslt120.lzh)ѤƤ
	ʬͭޤ

*/

#include "Masl.h"
#include "MaslAudio.h"
#include "audio.h"
#include "Palette.h"
#include "Cell.h"
#include "maslCommand.h"
#include "CopyImage2Root.h"

/*
*masl˹Ԥʤѿν
*audio deviceopenԤʤ
*/
void Masl::preparePlay ()
{
  ///////////////////////////////////////////////Ƽѿν
  pt=scenario->getBeginPoint ();

  //dwTickCount.tv_sec=dwTickCount.tv_usec=0;
  //timerCount.tv_sec =timerCount.tv_usec =0;
  //hz=scenario->getTimerCounter ();

  timer.reset ();
  timer.setCount (scenario->getTimerCounter ());
  timeCntForWait=0;
  isWaiting=False;
  is200LineMode=False;
  isGraphicOn=True;

  aheadlyExtractedCellNumber=-1;
  delete cellAhead;
  cellAhead=NULL;

  isAudioWriting=False;
  isAudioWaiting=False;

  numberOfCall=0;
  numberOfLoop=0;
  nShowPage=0;
  nDrawPage=0;
  viewPort.left=0;
  viewPort.top=0;
  viewPort.right=SIZE_X-1;
  viewPort.bottom=SIZE_Y-1;
  if (xmaslOption.isFullsize)//full mode
    viewPort.bottom=VRAM_SIZE_Y-1;
  nVramOrg=0;
  gdcLoop=PLANE_LENGTH;
  
  errorLevel=NULL;
  normalExit=0;//νͤˤϰ̣ͭޤ
  escapeExit=-1;//νͤˤϰ̣ͭޤ
  
  memset (intVar,0,sizeof (intVar));
  //ͤǤѿνͤɤʤΤǤ(꤫)dataˤ
  //ͤ0ǤԤƤʪͭΤǰ0clearƤޤ

#ifdef DEBUG_MODE
  if (xmaslOption.isDebugMode)
    debugMode=new MaslDebugMode (this,
				 scenario->getBeginPoint (),
				 scenario->getScenarioSize ()-
				 (scenario->getBeginPoint ()-
				  scenario->getScenarioTop ()),
				 intVar,xmaslOption.isBreakMode,
				 xmaslOption.ttyOfDebugMode);//debug modeν
#endif//DEBUG_MODE


  //audio device open
  if (numberOfPcm>0)
    {
      if (!(MaslAudio::openAudioDevice ()))
	{
	  cerr << "masl:can not open audio device." << endl;
	  cerr << "continue playing data with no audio." << endl;
	  MaslAudio::disableAudio ();
	}
      //ϤäɤΤʤ̵ɤ⡢
      //sample rateꤷƤʤΤͭ褦
      if (!(MaslAudio::initializeAudioDevice (DEFAULT_SAMPLE_RATE)))
	{
	  cerr << "masl:can not initialize PCM rate." << endl;
	  cerr << "may play audio with wrong sampling rate." << endl;
	}
    }
  else
    {//PCM data̵Τaudio̵ˤƤ
      MaslAudio::disableAudio ();
    }
  MaslAudio::prepareMaslAudio (&isAudioWriting,&isAudioWaiting);
}

/*
*audio deviceclose
*/
void Masl::afterPlay ()
{
  //sound deviceclose
  MaslAudio::offAudioTimer ();
  if (MaslAudio::isAudioEnabled ())
    MaslAudio::closeAudioDevice ();

  if (xmaslOption.isPause)//λkeyԤ򤹤
    {
      XEvent tmpEvent;
      for (;;)
	{
	  XNextEvent (display,&tmpEvent);
	  if (tmpEvent.type==KeyPress)//key줿齪λ
	    break;
	  updateWindow ();//ʳʤ
	}
    }

#ifdef DEBUG_MODE
  if (xmaslOption.isDebugMode)
    delete debugMode;//debug modeθ
#endif//DEBUG_MODE
}


Bool Masl::play ()
{
  if (timer.isNotStarted ())
    timer.start ();
  
  for (;;)
    {
    CONTINUE:

#ifndef USE_OLD_TIMER_WAIT
      if (waitTimerOrHandleEvent ()==False)
	return False;
#else
      ////////////////////////////////////////////////////////Xevent
      if (XCheckMaskEvent (display,maslEventMask,&event))
	{
	  if (handleEvent (event)==False)
	    return False;
	}
# ifdef DEBUG_MODE
      ////////////////////////////////////////////////////////debug mode
      if (xmaslOption.isDebugMode)
	debugMode->updataParam ();//debug modedataι(keyԤϤʤ)
# endif //DEBUG_MODE
#endif //USE_OLD_TIMER_WAIT

      ///////////////////////////////////////////////////////PCMԤ
      if (isAudioWaiting!=0)
	{
#ifdef MIX_AUDIO
	  if ((isAudioWriting & isAudioWaiting)!=0)
#else
	  if (isAudioWriting!=0)
#endif
	    {
	      //continue;
	      return True;
	    }
#ifdef MIX_AUDIO
	  //do nothing
#else
	  MaslAudio::sync ();
#endif
	  isAudioWaiting=0;
	}
      
#ifdef USE_OLD_TIMER_WAIT
      ///////////////////////////////////////////////timerϢ(timer countԤ)
      if (isWaiting)
	{//timerԤ
          if (timer.getNowCount ()<(long)timeCntForWait*100)
	    {//timerԤʤΤǡ롣
	      //continue;
	      return True;
	    }

	  //timerԤλ
	  timeCntForWait=0;
	  isWaiting=False;
	  if (*pt=='c')//tP1cä
	    {
	      pt++;
	      timer.clearTimer ();
	    }
	}
#endif //USE_OLD_TIMER_WAIT
      
      //////////////////////////////////////////scenarioϤλϤޤ
      if (searchNextCommand ()==False)
	return False;

      ///////////////////////////////////////////  command&¹
      for (int i=0;i<numberOfCommand;i++)
	{
	  if (strncmp (pt,commandTable[i].command,
		       strlen (commandTable[i].command))==0)//commandβ
	    {
#ifdef DEBUG_MODE
	      ////////////////////////////////////////debug mode
	      if (xmaslOption.isDebugMode)
		debugMode->printData (pt);//debug modeɽ(keyԤ⤹)
#endif //DEBUG_MODE

	      commandTable[i].executeCommand (*this);//command¹
	      //goto CONTINUE;
	      return True;
	    }
	}

      if (*pt=='\\')//\:scenarioνλ
	{//'\n'
	 //εǽ  ̤nΰŤˤƥʥꥪλ
	 //   '\100' - ̤򤽤Τޤޤˤƽλ
	 //P1άϲ̤õƽλޤ
	  pt++;
	  int contrast=0;
	  if (isdigit (*pt))
	    contrast=getValue ();
	  Palette::setTone (contrast);
	  return False;
	}     
      
      ////////////////error
      if (*pt=='@'||*pt=='.'||*pt=='\'')
	{
	  pt++;
	  continue;
	}

      if (isdigit (*pt))
	{
	  searchnum ();
	  continue;
	}
      
      while (*pt!=' ' && *pt!='\t' && *pt!='\r' && *pt!='\n' 
	     && *pt!=';' && scenario->isNotEnd (pt))
	{
	  pt++;
	}

      if (scenario->isEnd (pt))
	{
	  return False;
	}
    }//for (;;)
}

///////////////////////////////////////////Event Handler
Bool Masl::handleEvent (XEvent event)
{
  switch (event.type)
    {
    case KeyPress:
      do
	{
	  switch(XKeycodeToKeysym (display,event.xkey.keycode,0))
	    {
	    case XK_Escape://Escape keyƤкλ
	      if (errorLevel!=NULL)
		{//error levelꤵƤ
		  //error levelescapeǽλꡣ
		  errorLevel=&escapeExit;
		}
	      MaslAudio::resetAudio ();//PCMߤ롣
	      return False;
	      break;//ǰΰ
	    default://do nothing
	      break;
	    }
      	}while (XCheckTypedEvent (display,KeyPress,&event));//;ʬʥ٥Ȥɤ
      break;
    case Expose://̤κ
      //;ʬʥ٥Ȥɤ߼Τ
      while (XCheckTypedEvent (display,Expose,&event))
	;//do nothing ;ʬʥ٥Ȥɤ߼Τ 
      updateWindow ();
      break;
    case ButtonPress:
      switch (event.xbutton.button)
	{
	case 1:
	  {
	    CopyImage2Root copyImage2Root (display,screen,window,
					   planeMask[0]|planeMask[1]|
					   planeMask[2]|planeMask[3]);
	    copyImage2Root.copyImage2Root ();
	  }
	break;
	case 2:
	  XIconifyWindow (display,window,screen);
	  break;
	default:
	  break;//⤷ʤ
	}
      break;
    default://ʤΤʤǰΰ
      //⤷ʤ
      break;
    }
  
  return True;
}

#ifndef USE_OLD_TIMER_WAIT
Bool Masl::waitTimerOrHandleEvent ()
{
  if (!isWaiting)
    {//timerԤǤʤ̾Event Handling
      XEvent event;
      if (XCheckMaskEvent (display,maslEventMask,&event))
	{
	  if (handleEvent (event)==False)
	    return False;
	}
    }
  else
    {///////////////////////////////////////////////timerϢ(timer countԤ)
      /////////////////////////////////////////////////timerԤ
      while (timer.getNowCount ()<(long)timeCntForWait*100)
	{//timerԤʤΤǡ롣
	  XSync (display,False);
	  XEvent event;
	  while (XCheckMaskEvent (display,maslEventMask,&event))
	    {
	      if (handleEvent (event)==False)
		return False;
	      if (!(timer.getNowCount ()<(long)timeCntForWait*100))
		goto WAIT_IS_OVER;
	    }
#ifdef DEBUG_MODE
	  ////////////////////////////////////////////////////////debug mode
	  if (xmaslOption.isDebugMode)
	    {//debug modedataι(keyԤϤʤ)
	      debugMode->updataParam ();
	      continue;
	    }
#endif //DEBUG_MODE
	  ////////////////////////////////////////////timerԤ
	  /////////////////////////////////xlockmore򻲹ͤˤޤ
	  timeval leftTime=timer.getLeftTimeVal (timeCntForWait*100);
	  int xfd=ConnectionNumber (display);
	  fd_set reads;
	  FD_ZERO (&reads);
	  FD_SET (xfd,&reads);
	  int result=select (xfd+1,&reads,NULL,NULL,&leftTime);

	  if (result==0)
	    break;//time out.timerԤλ
	  if (result==1)
	    continue;//event褿
	  if (result>0 || (result==-1 && errno!=EINTR))
	    cerr << "Unexpected selcet () return value=" << result << endl;
	}

    WAIT_IS_OVER:
      ////////////////////////////////////////timerԤλ
      timeCntForWait=0;
      isWaiting=False;
      if (*pt=='c')//tP1cä
	{//m-maslǤ̵ʤäʪΤޤޤǳ̵Τ
	  //ΤޤޤˤƤ롣
	  pt++;
	  timer.clearTimer ();
	}
    }

  return True;
}
#endif //USE_OLD_TIMER_WAIT
