/* 
        testak5.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>

#include "Masl.h"
#include "Cell.h"
#include "audio.h"
#include "Pcm.h"

main (int argc,char** argv)
{
  XMASL_OPTION xmaslOption=XMASL_OPTION ();

  static String fallbackResources[]=
  {
    NULL,
  };
  
  XtAppContext appContext;
  Widget topLevel;
  XtToolkitInitialize ();
  topLevel=XtVaAppInitialize (&appContext,APP_CLASS_NAME,NULL,ZERO,
			      &argc,argv,fallbackResources,
			      XtNwidth,SIZE_X,XtNheight,SIZE_Y,NULL);
  Display* display=XtDisplay (topLevel);
  Masl masl=Masl (display,argc,argv,argv[1],xmaslOption);
  
  cout << "masl.numberOfCell=" << masl.numberOfCell << endl;
  cout << "masl.numberOfPalette=" << masl.numberOfPalette << endl;
  cout << "masl.numberOfPCM=" << masl.numberOfPcm << endl;
  
  masl.pPalette[0]->setPalette ();
  XFlush (masl.display);
  
#ifdef MITSHM
  XShmSegmentInfo SHMInfo;
  XImage* image=XShmCreateImage (masl.display,masl.visual,8,
				  ZPixmap,NULL,&SHMInfo,SIZE_X,SIZE_Y);
  if (!image)
    perror ("can not create MITSHM Image.");
  SHMInfo.shmid=shmget(IPC_PRIVATE, 
		       image->bytes_per_line*image->height,
		       IPC_CREAT|0777);
  if (SHMInfo.shmid<0) 
    perror("can not get MITSHM info.");
  unsigned char* imageData=(unsigned char*)(image->data=
					    SHMInfo.shmaddr=
					    shmat(SHMInfo.shmid,0,0));
  if (!imageData) 
    perror("can not allocate MITSHM.");
  SHMInfo.readOnly=False;
  if (!XShmAttach(masl.display,&SHMInfo)) 
    perror("can not attach MITSHM.");
#else
  unsigned char* imageData=new unsigned char[PLANE_LENGTH*8];
  memset (imageData,0,PLANE_LENGTH*8);//memory 
  XImage* image=XCreateImage (masl.display,masl.visual,8,ZPixmap,0,
		      (char*) imageData,SIZE_X,SIZE_Y,8,0);
#endif //MITSHM

  for (int i=0;i<masl.numberOfCell;i++)
    {
      cout << i << "-th image:size=" << masl.pCell[i]->header.right
	   << "x" << masl.pCell[i]->header.bottom << endl;
      memset (imageData,0,PLANE_LENGTH*8);//memory 
      //masl.pCell[i]->putImage (masl.display,masl.window,masl.gc,0,0);
      masl.pCell[i]->putImage (masl.display,masl.window,masl.gc,image,0,0);
      XFlush (masl.display);
      for (;;)
        {
          XEvent event;
          XNextEvent (display,&event);
          if (event.type==ButtonPress||event.type==KeyPress)
            break;
	  masl.pCell[i]->putImage (masl.display,masl.window,masl.gc,image,0,0);
	  XFlush (masl.display);
        }
    }


  if (!(Audio::openAudioDevice ()))
    {
      cerr << "can not open audio device." << endl;
      exit (-1);
    }

  if (masl.numberOfPcm>0)
    {
      if (!(Audio::initializeAudioDevice ((masl.pPcm[0]->PcmRate))))
	{
	  cerr << "can not initialize audio device." << endl;
	  exit (-1);
	}
      
      for (int i=0;i<masl.numberOfPcm;i++)
	{
	  cout << i << "-th ADPCM" << endl;
	  cout << "rate=" << masl.pPcm[i]->PcmRate 
	       << ".now playing..." << flush;
	  masl.pPcm[i]->play ();
	  Audio::sync ();
	  Audio::post ();
	  cout << "done." << endl;
	  getchar ();
	}
    }

  Audio::closeAudioDevice ();
}
