/* 
        xmasl.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        codeshimarincode򸵤YamahataΤǤ

*/
#include <iostream.h>

#include "Masl.h"
#include "Cell.h"
#include "audio.h"

static void printUsage ();
static void analyseXmaslOption (const char* const,XMASL_OPTION* xmaslOption);
static Masl* masl;
static void whenExit ()
{
  delete masl;
  //cerr << "whenExit is called" << endl;
}

int
main (int __argc,char** const __argv)
{
  int maslFileOffset=1;
  char msl[]=".msl";
  char MSL[]=".MSL";
  while (maslFileOffset<__argc)
    {/* *.mslܤ˻ꤵƤ뤫Ĵ٤롣*/
      if (strcmp (__argv[maslFileOffset]+strlen (__argv[maslFileOffset])-4,msl)
	  ==0 ||
	  strcmp (__argv[maslFileOffset]+strlen (__argv[maslFileOffset])-4,MSL)
	  ==0)
	break;
      maslFileOffset++;
    }
  if (maslFileOffset==__argc)
    {
      cerr << "no *.msl file is specified." << endl;
      printUsage ();
      exit (-1);
    }
  
  ///////////////////////////////////////////////resouce & option
  static String fallbackResources[]=
  {
    NULL,
  };

  static XtResource resources[]=
  {
#ifdef MITSHM
    {"isUseMITSHM","IsUseMITSHM",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isUseMITSHM),
     XtRImmediate,(XtPointer)False},
#endif
    {"isAhead","IsAhead",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isAhead),
     XtRImmediate,(XtPointer)True},
    {"isStaticLowMemroy","IsStaticLowMemroy",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isStaticLowMemory),
     XtRImmediate,(XtPointer)False},
    {"isStatic","IsStatic",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isStatic),
     XtRImmediate,(XtPointer)False},
    {"isTraceMode","IsTraceMode",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isTraceMode),
     XtRImmediate,(XtPointer)False},
    {"isNoSound","IsNoSound",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isNoSound),
     XtRImmediate,(XtPointer)False},
    {"isNoPrintComment","IsNoPrintComment",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isNoPrintComment),
     XtRImmediate,(XtPointer)False},
    {"isWaitBeforePlaying","IsWaitBeforePlaying",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isWaitBeforePlaying),
     XtRImmediate,(XtPointer)False},
    {"isPause","IsPause",
     XtRBool,sizeof (XtRBool)
     ,XtOffset (class XMASL_OPTION*,isPause),
     XtRImmediate,(XtPointer)False},
    {"isForce400LineMode","IsForce400LineMode",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isForce400LineMode),
     XtRImmediate,(XtPointer)False},
    {"isWindowResizable","IsWindowResizable",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isWindowResizable),
     XtRImmediate,(XtPointer)False},
    {"isSjis","IsSjis",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isSjis),
     XtRImmediate,(XtPointer)False},
    {"useMask","UseMask",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,useMask),
     XtRImmediate,(XtPointer)True},
    {"isFullsize","IsFullsize",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isFullsize),
     XtRImmediate,(XtPointer)False},
    {"isUsePrivateColormap","IsUsePrivateColormap",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isUsePrivateColormap),
     XtRImmediate,(XtPointer)False},
#ifdef RENICE
    {"isRenice","IsRenice",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isRenice),
     XtRImmediate,(XtPointer)False},
#endif
#ifdef DEBUG_MODE
    {"isDebugMode","IsDebugMode",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isDebugMode),
     XtRImmediate,(XtPointer)False},
    {"iBreakMode","IsBreakMode",
     XtRBool,sizeof (XtRBool),
     XtOffset (class XMASL_OPTION*,isBreakMode),
     XtRImmediate,(XtPointer)False},
/* äƤɤꤷ餤ΤǤ礦?
    {"ttyOfDebugMode","TtyOfDebugMode",
     XtRChar*,sizeof (char*),
     XtOffset (class XMASL_OPTION*,ttyOfDebugMode),
     XtRImmediate,(XtPoint)NULL},
     */
#endif
  };

  XMASL_OPTION xmaslOption=XMASL_OPTION ();
  XtAppContext appContext;
  Widget topLevel;
  int optionNumber=maslFileOffset-1;
/*
  XtToolkitInitialize ();
  appContext=XtCreateApplicationContext ();
  Display* display=XtOpenDisplay (appContext,(String)NULL,NULL,APP_CLASS_NAME,
				  NULL,ZERO,&optionNumber,__argv);
  XtVaGetSubvalues ((caddr_t)&xmaslOption,resources,XtNumber (resources),NULL);
*/
  topLevel=XtVaAppInitialize (&appContext,APP_CLASS_NAME,NULL,ZERO,
			      &optionNumber,__argv,fallbackResources,
			      XtNwidth,SIZE_X,XtNheight,SIZE_Y,NULL);
  XtVaGetApplicationResources (topLevel,(caddr_t)&xmaslOption,
			       resources,XtNumber (resources),NULL);

  Display* display=XtDisplay (topLevel);
  if (display==NULL)
    {//X serverȤ³ʤä
      cerr << "Error Can not connect X server." << endl;
      exit (-1);
    }

  for (int i=1;i<maslFileOffset;i++)
    {
      if (__argv[i]==NULL)
	continue;//˾ǻѺѤ
      analyseXmaslOption (__argv[i],&xmaslOption);    
    }

#if 0
  int i=1;
  while (__argv[i]==NULL || __argv[i][0]=='-')
    {
      analyseXmaslOption (__argv[i],&xmaslOption);
      i++;
      if (i==__argc)
	{/* *.msl fileꤵƤ뤫check */
	  cerr << "no *.msl file is specified." << endl;
	  printUsage ();
	  exit (-1);
	}
    }
#endif

  /////////////////////////////////////////////////////////dataload
  masl=new Masl(display,
		__argc-maslFileOffset,__argv+maslFileOffset,
		__argv[maslFileOffset],xmaslOption);

  atexit (whenExit);
/*
#ifdef DEBUG  
  cerr << "masl is created" << endl;
#endif
*/

  /////////////////////////////////////////////////////////dataκ
  masl->preparePlay ();
  while (masl->play ())
    {
      //⤷ʤ
    }
  masl->afterPlay ();

  //////////////////////////////////////////////////////////
  XtDestroyWidget (topLevel);
  exit (masl->getErrorLevel ());
}

////////////////////////////option handler
#ifdef MITSHM
static void optionUseMITSHM (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isUseMITSHM=True;
}
#endif

static void optionStaticLowMemory (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isStaticLowMemory=True;
}

static void optionStatic(XMASL_OPTION* xmaslOption)
{
  xmaslOption->isStatic=True;
}

static void optionRealtimeDecode (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isStatic=False;
  xmaslOption->isStaticLowMemory=False;
}

static void optionNoSound (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isNoSound=True;
}

static void optionSound (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isNoSound=False;
}

static void optionTraceMode (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isTraceMode=True;
}

static void optionComment (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isNoPrintComment=False;
}

static void optionNoPrintComment (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isNoPrintComment=True;
}

static void optionHelp (XMASL_OPTION* xmaslOption)
{
  printUsage ();
  exit (0);
}

static void optionWait (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isWaitBeforePlaying=True;
}

static void optionPause (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isPause=True;
}

static void optionForce400LineMode (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isForce400LineMode=True;
}

static void optionWindowResizable (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isWindowResizable=True;
}

static void optionSjis (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isSjis=True;
}

static void optionEuc (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isSjis=False;
}

static void optionUseMask (XMASL_OPTION* xmaslOption)
{
  xmaslOption->useMask=True;
}

static void optionDisableMask (XMASL_OPTION* xmaslOption)
{
  xmaslOption->useMask=False;
}

static void optionAhead (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isAhead=True;
}

static void optionDemand (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isAhead=False;
}

static void optionFullsize (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isFullsize=True;
}

static void optionPrivateColormap (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isUsePrivateColormap=True;
}

#ifdef RENICE
static void optionRenice (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isRenice=True;
}
#endif //RENICE

static void optionNormalMode (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isTraceMode=False;
#ifdef DEBUG_MODE
  xmaslOption->isDebugMode=False;  
  xmaslOption->isBreakMode=False;
#endif //DEBUG_MODE
}
#ifdef DEBUG_MODE
static void optionDebugMode (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isDebugMode=True;
}

static void optionBreakMode (XMASL_OPTION* xmaslOption)
{
  xmaslOption->isBreakMode=True;
}
#endif //DEBUG_MODE

struct XmaslOption
{
  char* optionName;
  void (*setOption) (XMASL_OPTION* xmaslOption);
};

static
XmaslOption xmaslOptionTable[]=
{
  {"-ahead",optionAhead},//Ÿǽͭˤ
  {"a",optionAhead},
#ifdef DEBUG_MODE
  {"-break",optionBreakMode},
  {"b",optionBreakMode},
#endif//DEBUG_MODE
  {"-comment",optionComment},//commentɽ
  {"c",optionNoPrintComment},
  {"-commentless",optionNoPrintComment},//commentɽʤ
#ifdef DEBUG_MODE
  {"-debug",optionDebugMode},
  {"d",optionDebugMode},
#endif//DEBUG_MODE
  {"-demand",optionDemand},//Ÿǽ̵ˤ롣
  {"-euc",optionEuc},//commenteucɽ롣
  {"e",optionEuc},//commenteucɽ롣
  {"-force400line",optionForce400LineMode},//Ū400line modeɽ
  {"f",optionForce400LineMode},
  {"-full",optionFullsize},//98vramΤɽ
  {"-help",optionHelp},//usageɽ
  {"h",optionHelp},
  {"-maskless",optionDisableMask},//maskѤʤ
  {"-mask",optionUseMask},//maskѤ
#ifdef MITSHM
  {"-mitshm",optionUseMITSHM},//MITSHM extentionѤ롣
  {"m",optionUseMITSHM},//MITSHM extentionѤ롣
#endif
  {"-normal",optionNormalMode},//normal mode
  {"-nosound",optionNoSound},//PCM̵
  {"n",optionNoSound},
  {"-pause",optionPause},//λkeyԤ򤹤
  {"p",optionPause},
  {"-private",optionPrivateColormap},//private color mapŪ˻Ѥ롣
#ifdef RENICE
  {"-RENICE",optionRenice},//processμ¹̤ͥ夲롣
  {"R",optionRenice},
#endif//RENICE
  {"-resizable",optionWindowResizable},//windowsizeѹǧ롣
  {"r",optionWindowResizable},
  {"-realtime",optionRealtimeDecode},//ŸưŪ˹Ԥʤ
  {"-STATIC",optionStaticLowMemory},
  {"S",optionStaticLowMemory},
  {"-static",optionStatic},//Ūcg dataŸ뤫
  {"s",optionStatic},
  {"-sound",optionSound},//soundonˤ롣
  {"-sjis",optionSjis},
  {"-trace",optionTraceMode},//trace mode(mode)
  {"t",optionTraceMode},
  {"-wait",optionWait},//ϻkeyԤ򤹤
  {"w",optionWait},
};

#define MAX_OPTIONS ((int) (sizeof (xmaslOptionTable)/sizeof (XmaslOption)))

////////////////////////////////////////////invalid option
static void printInvalidOption(const char* const option)
{	      
  cerr << "invalid option:" << option << endl;
  printUsage ();
  exit (-1);
}

///////////////////////////////ºݤoptionꤹ롣
static void analyseXmaslOption
(const char* const option,XMASL_OPTION* xmaslOption)
{
  if (option[1]=='-')
    {//long style(--hoegehogeη)
      for (int i=0;i<MAX_OPTIONS;i++)
	{
	  if (strcmp (xmaslOptionTable[i].optionName,option+1)==0)
	    {
	      xmaslOptionTable[i].setOption (xmaslOption);
	      return;
	    }
	}
      //option̵ä
      printInvalidOption (option);//comment outɤʡ
    }
  else
    {//short style(-hogehogeη)
      for (int j=1;j<(int) strlen (option);j++)
	{
	  int i=0;
	  while (i<MAX_OPTIONS)
	    {
	      if (*(xmaslOptionTable[i].optionName)==*(option+j) &&
		  *(xmaslOptionTable[i].optionName)!='-')//long style̵
		{
		  xmaslOptionTable[i].setOption (xmaslOption);
		  break;
		}
	      i++;
	    }
	  if (i==MAX_OPTIONS)
	    {//option̵ä
	      printInvalidOption (option);//comment outɤʡ
	    }
	}
      return;
    }
}

////////////////////////////////////////////erroro
static void printUsage ()
{
  cerr << "Usage:xmasl [options] filename [scenario-options]"<< endl;
  //cerr << "scenario-options are "
  cerr << "options:" << endl;
  cerr << "-a,--ahead:extracting data ahead of scenario" << endl;
#ifdef DEBUG_MODE
  cerr << "-b,--break:break mode when debug mode" << endl;
#endif
  cerr << "-c,--comment:print comment" << endl;
  cerr << "--commentless:print no comment" << endl;
#ifdef DEBUG_MODE
  cerr << "-d,--debug:debug mode" << endl;
#endif
  cerr << "--demand:disable aheadly extracting" << endl;
  cerr << "-e,--euc:output comment by Japanese EUC code" << endl;
  cerr << "-f,--force400line:force 400line mode" << endl;
  cerr << "--full:show full 98VRAM" << endl;
  cerr << "-h,--help:print this message and exit" << endl;
  cerr << "--mask:enable mask function" << endl;
  cerr << "--maskless:disable mask function" << endl;
#ifdef MITSHM
  cerr << "-m,--mitshm:use MITSHM extention" << endl;
#endif
  cerr << "--normal:play data normaly(disable debug mode)" << endl;
  cerr << "-n,--nosound:play with no sound" << endl;
  cerr << "-p,--pause:wait for keypressing when playing finished" << endl;
  cerr << "--private:force using private colormap." << endl;
#ifdef RENICE
  cerr << "-R,--RENICE:raise priority" << endl;
#endif
  cerr << "-r,--resizable:enable resize window" << endl;
  cerr << "--realtime:realtime decode graphic data" << endl;
  cerr << "-S,--STATIC:statically decode graphic data with low memory" << endl;
  cerr << "-s,--static:statically decode graphic data" << endl;
  cerr << "--sjis:output comment by sjis code" << endl;
  cerr << "--sound:play with sound" << endl;
  cerr << "-t,--trace:trace mode" << endl;
  cerr << "-w,--wait:wait for keys before playing" << endl;
}
